
function rdfObject (myUri, myDataId, myNS) {

  try {
    this.myRdf=Components.classes['@mozilla.org/rdf/rdf-service;1']
                   .getService(Components.interfaces.nsIRDFService);
    this.myUtils=Components.classes['@mozilla.org/rdf/container-utils;1']
                   .getService(Components.interfaces.nsIRDFContainerUtils);
    this.myContainer=Components.classes['@mozilla.org/rdf/container;1']
                   .createInstance(Components.interfaces.nsIRDFContainer);

    this.myDS = this.myRdf.GetDataSource(myUri);

    this.myId = 'urn:'+myDataId+':';

    var myNode = this.myRdf.GetResource(this.myId+'root');  
    this.myUtils.MakeSeq(myDS,myNode);
    this.myContainer.Init(myDS, myNode);
    
    this.myNS = myNS;

  } catch(e) { alert("Error creating rdfobject!\n\n"+e); }

};

rdfObject.prototype = 
{

  myDS: null,
  myUtils: null,
  myContainer: null,
  myId: null,
  myRdf: null,
  myNS: null,

  test: function(messagetosee)
  {
    alert("Test: \n"+messagetosee);
  },

  getResource: function(resID) {
    return this.myRdf.GetResource(this.myId+resID);
  },

  indexOf : function(resID) {

   var index = this.myContainer.IndexOf(this.getResource(resID));

   return (index > 0) ? index-1 : index ;

  },

  setData: function(resID, dataName, dataValue) {
      nameRes = this.myRdf.GetResource(this.myNS+dataName);
   
      oldValue = this.myDS.GetTarget(
  		this.getResource(resID), nameRes, true);
      if ( oldValue ) {
        this.myDS.Unassert(this.getResource(resID), nameRes, oldValue);
      }

    try {
      this.myDS.Assert(this.getResource(resID),nameRes,
                          this.myRdf.GetLiteral(dataValue),true);
      if ( this.myContainer.IndexOf(this.getResource(resID)) < 0 ) {
          if ( this.length() > 0 ) {
            this.myContainer.InsertElementAt(this.getResource(resID),1,true);
          } else {
            var pathName = this.getData("root", "path");
            this.delData("root");
            this.myUtils.MakeSeq(myDS, this.getResource("root"));
            this.myContainer.Init(myDS, this.getResource("root"));
            this.myContainer.AppendElement(this.getResource(resID));
            this.setData('root', 'path', pathName);
            this.hideData('root');
            this.flush();
          }
      }
    } catch(e) {alert("setData error:\n"+e);}
  },

  getData: function(resID, dataName) {
    try {
      nameRes = this.myRdf.GetResource(this.myNS+dataName);
      getRes = this.myDS
		.GetTarget(this.getResource(resID), nameRes,true);
      if ( getRes )
        return getRes.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
      else return ""; // Did it here?
    } catch (e) { alert("Error in getData:\n\n"+e); }
  },

  hideData: function(resID) {
    this.myContainer.RemoveElement( this.getResource(resID), true); 
    this.flush();
  },

  delData: function(resID) {
     var ArcChild = this.myRdf
                     .GetResource("http://home.netscape.com/NC-rdf#child");
     var dsRoot = this.myRdf.GetResource("Flipper:Root");
     var delRes = this.getResource(resID);
     while (this.myDS.HasAssertion(dsRoot, ArcChild, delRes, true)) 
       this.myDS.Unassert(dsRoot, ArcChild, delRes, true); 
     var relInfos = this.myDS.ArcLabelsOut(delRes);
     while ( relInfos.hasMoreElements() ) {
       var myInfo = relInfos.getNext()
             .QueryInterface(Components.interfaces.nsIRDFResource);
       var myTarget = this.myDS.GetTarget(delRes, myInfo, true);
       this.myDS.Unassert(delRes, myInfo, myTarget, true);
     }
     this.myContainer.RemoveElement( this.getResource(resID), true); 
     this.flush();
  },
 
  item: function(idx) {

    var enumNodes = this.myContainer.GetElements();

    var cnt = 0, found = 0;

    var node = null;

    while ( !found && enumNodes.hasMoreElements() ) {
      if ( cnt++ == idx ) found = 1;
      node = enumNodes.getNext();
    } 

    uriValue = node.QueryInterface(Components.interfaces.nsIRDFResource).Value;

   try {
      var pieces = new Array();
      pieces = uriValue.split(':');
      uriValue = pieces[2];
   } catch (e) { alert("Splitting: "+e); }

    if (found) return uriValue;

  },

  length: function() {
    try {
      return this.myContainer.GetCount();
    } catch(e) { 
      return 0;
    }
  },

  flush: function() {
    try {
      remoteDS = myDS
              .QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
      remoteDS.Flush();
    } catch(e) { alert("Error flushing: \n\n"+e) };
  }
};
